"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Install = exports.Run = void 0;
const shelljs_1 = require("shelljs");
const comands_1 = require("../../../enums/comands");
const message_1 = require("../../../enums/message");
const fs = __importStar(require("fs"));
const code_1 = require("./enums/code");
const Run = ({ code, input, timeout, similarWorkingJobCount, afterRunTest, }) => __awaiter(void 0, void 0, void 0, function* () {
    const time = Date.now();
    const process = (0, shelljs_1.exec)(`tsp -S ${similarWorkingJobCount} &&
      mkdir -p /${comands_1.Comands.Dir}/${comands_1.Comands.JavaDir} && mkdir -p /${comands_1.Comands.Dir}/${comands_1.Comands.JavaDir}/${time}
      && touch /${comands_1.Comands.Dir}/${comands_1.Comands.JavaDir}/${time}/main.sh && 
      touch /${comands_1.Comands.Dir}/${comands_1.Comands.JavaDir}/${time}/main.java`);
    const options = {};
    if (timeout) {
        options.timeout = timeout;
    }
    const commands = [
        `mkdir -p /${comands_1.Comands.Dir}/${comands_1.Comands.JavaDir}/${time}/example &&`,
        `mkdir -p /${comands_1.Comands.Dir}/${comands_1.Comands.JavaDir}/${time}/example/src &&`,
        `mkdir -p /${comands_1.Comands.Dir}/${comands_1.Comands.JavaDir}/${time}/example/src/test &&`,
        `mkdir -p /${comands_1.Comands.Dir}/${comands_1.Comands.JavaDir}/${time}/example/src/test/java &&`,
        `mkdir -p /${comands_1.Comands.Dir}/${comands_1.Comands.JavaDir}/${time}/example/src/test/java/example &&`,
        `touch /${comands_1.Comands.Dir}/${comands_1.Comands.JavaDir}/${time}/example/Jenkinsfile &&`,
        `echo ${JSON.stringify(code_1.Code.JENKINS)} > /${comands_1.Comands.Dir}/${comands_1.Comands.JavaDir}/${time}/example/Jenkinsfile &&`,
        `touch /${comands_1.Comands.Dir}/${comands_1.Comands.JavaDir}/${time}/example/pom.xml &&`,
        `echo ${JSON.stringify(code_1.Code.POM)} > /${comands_1.Comands.Dir}/${comands_1.Comands.JavaDir}/${time}/example/pom.xml &&`,
        `touch /${comands_1.Comands.Dir}/${comands_1.Comands.JavaDir}/${time}/example/src/test/java/example/Base.java &&`,
        `echo ${JSON.stringify(code_1.Code.Base)} > /${comands_1.Comands.Dir}/${comands_1.Comands.JavaDir}/${time}/example/src/test/java/example/Base.java &&`,
        `touch /${comands_1.Comands.Dir}/${comands_1.Comands.JavaDir}/${time}/example/src/test/java/example/MainTest.java &&`,
        `echo ${JSON.stringify(`
    ${code_1.Code.ImportMain}
    ${code}
    ${afterRunTest || ""}
    `)} > /${comands_1.Comands.Dir}/${comands_1.Comands.JavaDir}/${time}/example/src/test/java/example/MainTest.java &&`,
        `echo ${JSON.stringify(`
    ${code}
    `)} > /${comands_1.Comands.Dir}/${comands_1.Comands.JavaDir}/${time}/main.java && echo ${JSON.stringify(input)} > /${comands_1.Comands.Dir}/${comands_1.Comands.JavaDir}/${time}/input.txt
  `,
        `\n`,
        `javac /${comands_1.Comands.Dir}/${comands_1.Comands.JavaDir}/${time}/main.java`,
        `\n`,
    ];
    if (!afterRunTest) {
        if (input) {
            commands.push(`java -Xms128m -Xmx512m -classpath "/${comands_1.Comands.Dir}/${comands_1.Comands.JavaDir}/${time}/" Main  < /${comands_1.Comands.Dir}/${comands_1.Comands.JavaDir}/${time}/input.txt > /${comands_1.Comands.Dir}/${comands_1.Comands.JavaDir}/${time}/output.txt`);
            commands.push(`\n`);
        }
        else {
            commands.push(`java -Xms128m -Xmx512m -classpath "/${comands_1.Comands.Dir}/${comands_1.Comands.JavaDir}/${time}/" Main > /${comands_1.Comands.Dir}/${comands_1.Comands.JavaDir}/${time}/output.txt`);
            commands.push(`\n`);
        }
    }
    if (afterRunTest) {
        commands.push(`cd /${comands_1.Comands.Dir}/${comands_1.Comands.JavaDir}/${time}/example && mvn test && cd ../../../../`);
    }
    else {
        commands.push(`cat /${comands_1.Comands.Dir}/${comands_1.Comands.JavaDir}/${time}/output.txt`);
    }
    yield fs.writeFileSync(`/${comands_1.Comands.Dir}/${comands_1.Comands.JavaDir}/${time}/main.sh`, commands.join(" "), "utf8");
    const execute = process.exec(`tsp sh /${comands_1.Comands.Dir}/${comands_1.Comands.JavaDir}/${time}/main.sh`, Object.assign({}, options));
    if (!(execute === null || execute === void 0 ? void 0 : execute.stdout) || (execute === null || execute === void 0 ? void 0 : execute.stderr)) {
        throw new Error("not get proccess id");
    }
    const id = +execute.stdout;
    if (typeof id !== "number") {
        throw new Error("not get proccess id");
    }
    const timer = setTimeout(() => __awaiter(void 0, void 0, void 0, function* () {
        yield new Promise((resolve) => {
            process.exec(`rm -rf /${comands_1.Comands.Dir}/${comands_1.Comands.JavaDir}/${time} && tsp -r ${id}`, Object.assign(Object.assign({}, options), { async: true }), (codes) => {
                resolve(codes);
            });
        });
        clearTimeout(timer);
    }), timeout);
    return {
        id,
        start_date: time,
    };
});
exports.Run = Run;
const Install = () => {
    if (!(0, shelljs_1.which)(comands_1.Comands.Java)) {
        (0, shelljs_1.exec)(comands_1.Comands.JavaInstall);
    }
    if (!(0, shelljs_1.which)(comands_1.Comands.Java)) {
        (0, shelljs_1.echo)(message_1.Message.Java);
    }
};
exports.Install = Install;
