export var Code;
(function (Code) {
    Code["JENKINS"] = "podTemplate(containers: [containerTemplate(name: 'maven', image: 'maven', command: 'sleep', args: 'infinity')]) {\n    node(POD_LABEL) {\n      checkout scm\n      container('maven') {\n        sh 'mvn -B -ntp -Dmaven.test.failure.ignore verify'\n      }\n      junit '**/target/surefire-reports/TEST-*.xml'\n    }\n  }\n  ";
    Code["POM"] = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n  <project xmlns=\"http://maven.apache.org/POM/4.0.0\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xsi:schemaLocation=\"http://maven.apache.org/POM/4.0.0 http://maven.apache.org/xsd/maven-4.0.0.xsd\">\n      <modelVersion>4.0.0</modelVersion>\n      <groupId>test</groupId>\n      <artifactId>simple-maven-project-with-tests</artifactId>\n      <version>1.0-SNAPSHOT</version>\n      <packaging>jar</packaging>\n      <licenses>\n          <license>\n              <name>MIT License</name>\n              <url>http://opensource.org/licenses/MIT</url>\n          </license>\n      </licenses>\n      <build>\n          <plugins>\n              <plugin>\n                  <groupId>org.apache.maven.plugins</groupId>\n                  <artifactId>maven-surefire-plugin</artifactId>\n                  <version>2.18.1</version>\n              </plugin>\n          </plugins>\n      </build>\n      <dependencies>\n          <dependency>\n              <groupId>junit</groupId>\n              <artifactId>junit</artifactId>\n              <version>4.13.1</version>\n              <scope>test</scope>\n          </dependency>\n      </dependencies>\n      <properties>\n          <project.build.sourceEncoding>UTF-8</project.build.sourceEncoding>\n          <maven.compiler.source>1.7</maven.compiler.source>\n          <maven.compiler.target>1.7</maven.compiler.target>\n      </properties>\n  </project>\n  ";
    Code["Base"] = "package example;\n\n  import static org.junit.Assert.*;\n  import org.junit.internal.AssumptionViolatedException;\n  \n  class Base {\n  \n      protected void run() {\n          double r = Math.random();\n          if (r < 0.1) {\n              fail(\"oops\");\n          } else if (r < 0.2) {\n              throw new AssumptionViolatedException(\"skipping\");\n          }\n      }\n  }\n  ";
    Code["ImportMain"] = "\n  /*\n * The MIT License\n *\n * Copyright 2016 CloudBees, Inc.\n *\n * Permission is hereby granted, free of charge, to any person obtaining a copy\n * of this software and associated documentation files (the \"Software\"), to deal\n * in the Software without restriction, including without limitation the rights\n * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\n * copies of the Software, and to permit persons to whom the Software is\n * furnished to do so, subject to the following conditions:\n *\n * The above copyright notice and this permission notice shall be included in\n * all copies or substantial portions of the Software.\n *\n * THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\n * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\n * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\n * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\n * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\n * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN\n * THE SOFTWARE.\n */\n  package example;\n\n  import org.junit.Test;\n  import org.junit.Before;\n  import static org.junit.Assert.*;";
})(Code || (Code = {}));
